package com.sun.management.snmp.rfc2573.target.mib;
// java imports
//
import java.io.Serializable;

// jmx imports
//
import javax.management.MBeanServer;
import com.sun.management.snmp.SnmpString;
import com.sun.management.snmp.SnmpStatusException;

// jdmk imports
//
import com.sun.management.snmp.agent.SnmpMib;

//Contrib imports
import com.sun.management.snmp.rfc2573.target.SnmpTargetLcd;

public class SnmpTargetObjectsImpl extends SnmpTargetObjects {
    /**
     * Constructor for the "SnmpTargetObjects" group.
     * If the group contains a table, the entries created through an SNMP SET will not be registered in JDMK.
     */
    public SnmpTargetObjectsImpl(SnmpMib myMib, 
				 SnmpTargetLcd lcd) {
	super(myMib);
        SnmpTargetParamsTable = new TableSnmpTargetParamsTableImpl (myMib, lcd);
        SnmpTargetAddrTable = new TableSnmpTargetAddrTableImpl (myMib, lcd);
    }
    
    /**
     * Constructor for the "SnmpTargetObjects" group.
     * If the group contains a table, the entries created through an SNMP SET will be AUTOMATICALLY REGISTERED in JDMK.
     */
    public SnmpTargetObjectsImpl(SnmpMib myMib, 
				 MBeanServer server, 
				 SnmpTargetLcd lcd) {
	super(myMib, server);
        SnmpTargetParamsTable = new TableSnmpTargetParamsTableImpl (myMib, server, lcd);
        SnmpTargetAddrTable = new TableSnmpTargetAddrTableImpl (myMib, server, lcd);
    }
}
