package com.sun.management.snmp.rfc2573.v3proxy.mib;
// java imports
//
import java.io.Serializable;
import java.util.Hashtable;

// jmx imports
//
import javax.management.MBeanServer;
import javax.management.ObjectName;
import javax.management.InstanceAlreadyExistsException;

// jdmk imports
//
import com.sun.management.snmp.agent.SnmpMib;
import com.sun.management.snmp.agent.SnmpMibNode;
import com.sun.management.snmp.agent.SnmpMibTable;
import com.sun.management.snmp.agent.SnmpStandardObjectServer;

//Contrib imports
import com.sun.management.snmp.rfc2573.v3proxy.SnmpProxyLcd;
import com.sun.management.snmp.rfc2573.target.SnmpTargetLcd;
/**
 * The class is used for representing "SNMP-TARGET-MIB".
 * You can edit the file if you want to modify the behaviour of the MIB.
 */
public class SNMP_PROXY_MIBImpl extends SNMP_PROXY_MIB {
    SnmpProxyLcd proxyLcd = null;
    SnmpTargetLcd targetLcd = null;
    /**
     * Default constructor. Initialize the Mib tree.
     */
    public SNMP_PROXY_MIBImpl(SnmpProxyLcd proxyLcd,
			      SnmpTargetLcd targetLcd) {
	this.proxyLcd = proxyLcd;
	this.targetLcd = targetLcd;
    }
    
    public SNMP_PROXY_MIBImpl(MBeanServer server, 
			      SnmpProxyLcd proxyLcd,
			      SnmpTargetLcd targetLcd) {
	this.server = server;
	this.proxyLcd = proxyLcd;
	this.targetLcd = targetLcd;
    }
    
    protected Object createSnmpProxyObjectsMBean(String groupName,
						 String groupOid,  
						 ObjectName groupObjname, 
						 MBeanServer server)  {
	
        // Note that when using standard metadata,
        // the returned object must implement the "SnmpTargetObjectsMBean"
        // interface.
        //
        if (server != null) 
            return new SnmpProxyObjectsImpl(this, server, proxyLcd, targetLcd);
        else 
            return new SnmpProxyObjectsImpl(this, proxyLcd, targetLcd);
    }
}
